#include <bits/stdc++.h>
using namespace std;

using ll = long long;

ll inf = 1e9 + 7;

void first(ll n, ll k, vector<ll> &a) {
    vector<ll> p(n + 1), mn1(n + 2, inf), mn2(n + 2, inf), mx1(n + 2, 0), mx2(n + 2, 0);
    for (ll i = 1; i <= n; i++) {
        p[i] = p[i - 1] + a[i];
        mn1[i] = min(mn1[i - 1], a[i]);
        if (i > 1) {
            mx1[i] = max(mx1[i - 1], a[i] + a[i - 1]);
        }
    }
    for (ll i = n; i > 0; i--) {
        mn2[i] = min(mn2[i + 1], a[i]);
        if (i < n) {
            mx2[i] = max(mx2[i + 1], a[i] + a[i + 1]);
        }
    }
    ll k1 = n - k + 1;
    ll ans = -1;
    for (ll i = 1, j = k1; j <= n; ++j, ++i) {
        ll ans1 = p[j] - p[i - 1] - min(mn1[i - 1], mn2[j + 1]);
        if (k1 != 1) {
            if (a[j] == 0 && (i > 1 || j < n - 1)) {
                if (i > 1) {
                    ans1 = max(p[j] - p[i - 1], mx1[i - 1]);
                }
                if (j < n - 1) {
                    ans1 = max(p[j] - p[i - 1], mx2[j + 1]);
                }
            }
        }
        ans = max({ans, ans1});
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n + 1), p(n + 1);
    for (ll i = 1; i <= n; i++) {
        cin >> a[i];
        p[i] = p[i - 1] + a[i];
    }
    ll cnt0 = 0, cntb = 0, cntbb = 0, cnt = 0;
    vector<pair<ll, pair<ll, pair<ll, ll> > > > b;
    ll i1 = -1, j1 = -1;
    for (int i = 1; i <= n; ++i) {
        if (a[i] == 0) {
            cnt0++;
            if (i1 != -1) {
                b.push_back({(-1) * (p[i] - p[i1 - 1]), {cnt, {i1, i}}});
                ++cntb;
                cntbb += cnt;
            }
            i1 = -1;
            j1 = -1;
        }
        if (a[i] != 0) {
            if (i1 == -1) {
                i1 = i;
            }
            ++cnt;
        }
    }
    if (cntb > k) {
        first(n, k, a);
        return 0;
    }
    sort(b.begin(), b.end());
    if (cntb == k) {
        cout << b[0].first - b[b.size() - 1].first << '\n';
        return 0;
    }
    if (cntb + cnt0 >= k) {
        cout << b[0].first;
        return 0;
    }
    if (1 + cnt0 + cntbb - b[0].second.first >= k) {
        cout << b[0].first;
        return 0;
    }
    ll ans = 0;
    for (ll i = 0; i < b.size() && b[i].first == b[0].first; ++i) {
        ll sum = b[0].first;
        ll h = 1 + cnt0 + cntbb - b[0].second.first;
        i1 = b[i].second.second.first, j1 = b[i].second.second.second;
        while (h < k && i1 < j1) {
            if (a[i1] < a[j1]) {
                sum -= a[i1];
                ++h;
                ++i1;
            } else {
                sum -= a[j1];
                --j1;
                ++h;
            }
        }
        if (h == k) {
            ans = max(ans, sum);
        }
    }
    cout << ans;
    return 0;
}
